#############################################################################
##
#A  upperbd4.g 		        GUAVA library                   Reinald Baart
#A                                                       & Jasper Cramwinckel
#A                                                          & Erik Roijackers
##
##  This file contains a reference and an upper bound on the minimum distance
##  of a linear code over GF(4) of given word length and dimension.
##
#H  @(#)$Id: upperbd4.g,v 1.2 1997/01/20 15:34:46 werner Exp $
##
#Y  Copyright (C)  1994,  Vakgroep Algemene Wiskunde,  T.U. Delft,  Nederland
##
#H  $Log: upperbd4.g,v $
#H  Revision 1.2  1997/01/20 15:34:46  werner
#H  Upgrade from Guava 1.2 to Guava 1.3 for GAP release 3.4.4.
#H
#H  Revision 1.1  1994/11/10  14:29:23  rbaart
#H  Initial revision
#H
##
GUAVA_TEMP_VAR := [ 
[  10,   3,   6, "GH"  ],
[  19,   4,  12, "GH"  ],
[  19,   5,  11, "HLL" ],
[  28,   5,  18, "HLL" ],
[  30,  24,   4, "BK"  ],
[  32,   4,  22, "GH"  ],
[  39,  30,   6, "LP"  ],
[  43,  29,  10, "LP"  ],
[  46,   6,  31, "BK"  ],
[  47,  27,  15, "LP"  ],
[  48,  36,   8, "LP"  ],
[  49,   5,  34, "LP"  ],
[  51,  15,  27, "LP"  ],
[  51,  32,  14, "LP"  ],
[  52,  11,  31, "LP"  ],
[  52,  35,  12, "LP"  ],
[  53,   4,  38, "GH"  ],
[  53,   5,  37, "LP"  ],
[  55,   9,  35, "BK"  ],
[  56,   4,  40, "HLL" ],
[  56,  11,  34, "LP"  ],
[  57,  17,  30, "LP"  ],
[  57,  42,  10, "LP"  ],
[  58,   8,  38, "LP"  ],
[  58,  14,  33, "LP"  ],
[  60,  12,  36, "BK"  ],
[  60,  25,  26, "LP"  ],
[  60,  29,  23, "LP"  ],
[  60,  53,   4, "LP"  ],
[  61,  22,  29, "LP"  ],
[  61,  35,  19, "LP"  ],
[  61,  40,  15, "LP"  ],
[  61,  41,  14, "LP"  ],
[  61,  51,   6, "LP"  ],
[  62,   5,  44, "LP"  ],
[  62,   6,  43, "BK"  ],
[  62,  15,  35, "LP"  ],
[  64,  12,  39, "BK"  ],
[  64,  39,  18, "LP"  ],
[  65,  35,  22, "LP"  ],
[  66,  15,  38, "LP"  ],
[  66,  20,  34, "LP"  ],
[  66,  28,  28, "LP"  ],
[  66,  48,  12, "LP"  ],
[  67,   6,  46, "BK"  ],
[  67,  10,  43, "BK"  ],
[  67,  25,  31, "LP"  ],
[  67,  54,   8, "LP"  ],
[  68,  12,  42, "BK"  ],
[  68,  18,  37, "LP"  ],
[  69,  15,  40, "LP"  ],
[  69,  40,  21, "LP"  ],
[  69,  45,  17, "LP"  ],
[  70,  42,  20, "LP"  ],
[  70,  47,  16, "LP"  ],
[  71,  11,  45, "LP"  ],
[  71,  26,  33, "LP"  ],
[  72,  13,  44, "LP"  ],
[  72,  23,  36, "LP"  ],
[  72,  31,  30, "LP"  ],
[  72,  35,  27, "LP"  ],
[  73,  15,  43, "LP"  ],
[  73,  20,  39, "LP"  ],
[  74,   7,  51, "BK"  ],
[  74,  10,  48, "BK"  ],
[  74,  42,  23, "LP"  ],
[  74,  53,  14, "LP"  ],
[  75,   9,  50, "BK"  ],
[  75,  12,  47, "BK"  ],
[  75,  18,  42, "LP"  ],
[  75,  48,  19, "LP"  ],
[  76,  60,  10, "sph" ],
[  77,  16,  45, "LP"  ],
[  77,  21,  41, "LP"  ],
[  77,  25,  38, "LP"  ],
[  77,  29,  35, "LP"  ],
[  77,  37,  29, "LP"  ],
[  77,  41,  26, "LP"  ],
[  77,  46,  22, "LP"  ],
[  78,   7,  54, "BK"  ],
[  78,   8,  53, "LP"  ],
[  78,  10,  51, "BK"  ],
[  78,  34,  32, "LP"  ],
[  79,  12,  50, "BK"  ],
[  79,  13,  49, "BK"  ],
[  80,  15,  48, "LP"  ],
[  80,  45,  25, "LP"  ],
[  80,  54,  18, "sph" ],
[  81,   7,  56, "LP"  ],
[  81,  21,  44, "LP"  ],
[  82,   6,  58, "LP"  ],
[  82,  10,  54, "BK"  ],
[  82,  18,  47, "LP"  ],
[  82,  23,  43, "LP"  ],
[  82,  27,  40, "LP"  ],
[  82,  31,  37, "LP"  ],
[  82,  52,  21, "LP"  ],
[  83,  12,  53, "BK"  ],
[  83,  13,  52, "LP"  ],
[  83,  36,  34, "LP"  ],
[  83,  44,  28, "LP"  ],
[  83,  64,  12, "sph" ],
[  84,  15,  51, "LP"  ],
[  84,  16,  50, "LP"  ],
[  84,  21,  46, "LP"  ],
[  84,  41,  31, "LP"  ],
[  84,  60,  16, "sph" ],
[  85,  10,  56, "BK"  ],
[  85,  51,  24, "LP"  ],
[  86,   6,  61, "LP"  ],
[  86,   7,  60, "BK"  ],
[  86,   8,  59, "LP"  ],
[  86,  13,  54, "LP"  ],
[  86,  19,  49, "LP"  ],
[  87,   5,  63, "LP"  ],
[  87,  49,  27, "LP"  ],
[  88,  16,  53, "LP"  ],
[  88,  26,  45, "LP"  ],
[  88,  30,  42, "LP"  ],
[  88,  34,  39, "LP"  ],
[  88,  38,  36, "LP"  ],
[  88,  46,  30, "LP"  ],
[  89,   7,  62, "BK"  ],
[  89,  10,  59, "BK"  ],
[  89,  18,  52, "LP"  ],
[  89,  60,  20, "sph" ],
[  90,  13,  57, "LP"  ],
[  90,  24,  48, "LP"  ],
[  90,  44,  33, "LP"  ],
[  90,  53,  26, "LP"  ],
[  90,  57,  23, "LP"  ],
[  90,  58,  22, "LP"  ],
[  91,  16,  55, "LP"  ],
[  91,  21,  51, "LP"  ],
[  91,  30,  44, "LP"  ],
[  91,  69,  14, "sph" ],
[  92,   7,  64, "LP"  ],
[  92,  35,  41, "LP"  ],
[  93,  10,  62, "LP"  ],
[  93,  19,  54, "LP"  ],
[  93,  24,  50, "LP"  ],
[  93,  28,  47, "LP"  ],
[  93,  40,  38, "LP"  ],
[  93,  66,  18, "sph" ],
[  94,  13,  60, "LP"  ],
[  95,  16,  58, "LP"  ],
[  95,  22,  53, "LP"  ],
[  95,  46,  35, "LP"  ],
[  95,  50,  32, "LP"  ],
[  96,  82,   8, "sph" ],
[  97,   7,  68, "LP"  ],
[  97,  10,  65, "LP"  ],
[  97,  13,  62, "LP"  ],
[  97,  19,  57, "LP"  ],
[  97,  33,  46, "LP"  ],
[  97,  37,  43, "LP"  ],
[  98,  12,  64, "LP"  ],
[  98,  21,  56, "LP"  ],
[  98,  42,  40, "LP"  ],
[  99,   6,  71, "LP"  ],
[  99,  16,  61, "LP"  ],
[  99,  17,  60, "LP"  ],
[  99,  27,  52, "LP"  ],
[  99,  31,  49, "LP"  ],
[  99,  74,  16, "sph" ],
[  99,  82,  10, "sph" ],
[  99,  88,   6, "sph" ],
[ 100,  10,  67, "BK"  ],
[ 100,  19,  59, "LP"  ],
[ 100,  24,  55, "LP"  ],
[ 100,  48,  37, "LP"  ],
[ 100,  52,  34, "LP"  ],
[ 100,  56,  31, "LP"  ],
[ 100,  59,  29, "LP"  ],
[ 101,   7,  71, "LP"  ],
[ 101,  13,  65, "LP"  ],
[ 101,  71,  20, "sph" ],
[ 102,  16,  63, "LP"  ],
[ 102,  22,  58, "LP"  ],
[ 102,  27,  54, "LP"  ],
[ 102,  35,  48, "LP"  ],
[ 103,  32,  51, "LP"  ],
[ 103,  40,  45, "LP"  ],
[ 104,  10,  70, "LP"  ],
[ 104,  19,  62, "LP"  ],
[ 104,  25,  57, "LP"  ],
[ 104,  84,  12, "sph" ],
[ 105,   7,  74, "BK"  ],
[ 105,  13,  68, "LP"  ],
[ 105,  14,  67, "LP"  ],
[ 105,  22,  60, "LP"  ],
[ 105,  46,  42, "LP"  ],
[ 105,  50,  39, "LP"  ],
[ 106,  16,  66, "LP"  ],
[ 106,  17,  65, "LP"  ],
[ 106,  36,  50, "LP"  ],
[ 106,  71,  24, "sph" ],
[ 107,  19,  64, "LP"  ],
[ 107,  79,  18, "sph" ],
[ 108,   5,  79, "LP"  ],
[ 108,  10,  73, "LP"  ],
[ 108,  11,  72, "LP"  ],
[ 108,  30,  56, "LP"  ],
[ 108,  34,  53, "LP"  ],
[ 109,   7,  77, "LP"  ],
[ 109,  13,  71, "LP"  ],
[ 109,  14,  70, "LP"  ],
[ 109,  22,  63, "LP"  ],
[ 109,  27,  59, "LP"  ],
[ 109,  43,  47, "LP"  ],
[ 109,  47,  44, "LP"  ],
[ 110,   9,  76, "LP"  ],
[ 110,  16,  69, "LP"  ],
[ 110,  17,  68, "LP"  ],
[ 110,  77,  22, "sph" ],
[ 110,  87,  14, "sph" ],
[ 111,  19,  67, "LP"  ],
[ 111,  20,  66, "LP"  ],
[ 111,  25,  62, "LP"  ],
[ 111,  30,  58, "LP"  ],
[ 111,  34,  55, "LP"  ],
[ 112,  10,  76, "LP"  ],
[ 112,  11,  75, "LP"  ],
[ 112,  14,  72, "LP"  ],
[ 112,  39,  52, "LP"  ],
[ 112,  43,  49, "LP"  ],
[ 113,  13,  74, "LP"  ],
[ 113,  16,  71, "LP"  ],
[ 113,  17,  70, "LP"  ],
[ 113,  23,  65, "LP"  ],
[ 113,  73,  28, "sph" ],
[ 114,   9,  79, "LP"  ],
[ 114,  25,  64, "LP"  ],
[ 114,  29,  61, "LP"  ],
[ 115,  20,  69, "LP"  ],
[ 115,  39,  54, "LP"  ],
[ 115,  77,  26, "sph" ],
[ 116,  10,  79, "LP"  ],
[ 116,  11,  78, "LP"  ],
[ 116,  13,  76, "LP"  ],
[ 116,  14,  75, "LP"  ],
[ 116,  22,  68, "LP"  ],
[ 116,  28,  63, "LP"  ],
[ 116,  36,  57, "LP"  ],
[ 116,  44,  51, "LP"  ],
[ 116,  85,  20, "sph" ],
[ 117,   7,  83, "LP"  ],
[ 117,   8,  82, "LP"  ],
[ 117,  16,  74, "LP"  ],
[ 117,  17,  73, "LP"  ],
[ 117,  33,  60, "LP"  ],
[ 117,  91,  16, "sph" ],
[ 118,  19,  72, "LP"  ],
[ 118,  20,  71, "LP"  ],
[ 118,  25,  67, "LP"  ],
[ 119,  11,  80, "LP"  ],
[ 119,  14,  77, "LP"  ],
[ 119,  83,  24, "sph" ],
[ 120,   6,  87, "BK"  ],
[ 120,   7,  85, "BK"  ],
[ 120,  10,  82, "BK"  ],
[ 120,  13,  79, "LP"  ],
[ 120,  17,  75, "LP"  ],
[ 120,  23,  70, "LP"  ],
[ 120,  28,  66, "LP"  ],
[ 120,  33,  62, "LP"  ],
[ 120,  37,  59, "LP"  ],
[ 120,  41,  56, "LP"  ],
[ 121,  78,  30, "sph" ],
[ 121, 113,   4, "sph" ],
[ 122,  20,  74, "LP"  ],
[ 122,  26,  69, "LP"  ],
[ 122,  31,  65, "LP"  ],
[ 123,  11,  83, "LP"  ],
[ 123,  14,  80, "LP"  ],
[ 123,  22,  73, "LP"  ],
[ 123,  23,  72, "LP"  ],
[ 123,  28,  68, "LP"  ],
[ 124,   7,  88, "LP"  ],
[ 124,  10,  85, "LP"  ],
[ 124,  13,  82, "LP"  ],
[ 124,  17,  78, "LP"  ],
[ 124,  42,  58, "LP"  ],
[ 124,  83,  28, "sph" ],
[ 124,  90,  22, "sph" ],
[ 125,   9,  87, "LP"  ],
[ 125,  20,  76, "LP"  ],
[ 125,  26,  71, "LP"  ],
[ 125,  31,  67, "LP"  ],
[ 125,  35,  64, "LP"  ],
[ 125,  39,  61, "LP"  ],
[ 125,  96,  18, "sph" ],
[ 127,  11,  86, "LP"  ],
[ 127,  14,  83, "LP"  ],
[ 127,  17,  80, "LP"  ],
[ 127,  23,  75, "LP"  ],
[ 127,  88,  26, "sph" ],
[ 128,   7,  91, "LP"  ],
[ 128,  10,  88, "LP"  ],
[ 128,  13,  85, "LP"  ],
[ 129,   9,  90, "LP"  ],
[ 129,  20,  79, "LP"  ],
[ 129,  26,  74, "LP"  ],
[ 129,  31,  70, "LP"  ],
[ 129,  36,  66, "LP"  ],
[ 129,  40,  63, "LP"  ],
[ 129,  44,  60, "LP"  ],
[ 130,  11,  88, "LP"  ],
[ 130,  14,  85, "LP"  ],
[ 130,  23,  77, "LP"  ],
[ 130, 109,  12, "sph" ],
[ 130, 112,  10, "sph" ],
[ 131,  17,  83, "LP"  ],
[ 131,  29,  73, "LP"  ],
[ 132,   7,  94, "LP"  ],
[ 132,  10,  91, "LP"  ],
[ 132,  20,  81, "LP"  ],
[ 132,  35,  69, "LP"  ],
[ 132,  88,  30, "sph" ],
[ 132,  95,  24, "sph" ],
[ 132, 100,  20, "sph" ]];
